/*
  $Id: test1.c,v 1.2 1999-06-09 10:56:35-05 annis Exp $
  $Source: /home/orion/annis/code/NewMom/kstat/RCS/test1.c,v $

  Copyright (c) 1999 William S. Annis.  All rights reserved.  This
  is free software; you can redistribute it and/or modify it under the
  same terms as Perl (the Artistic Licence).

  Describe what's going on here.
*/

#include <stdio.h>
#include <errno.h>
#include <kstat.h>

int
main()
{
  kstat_ctl_t *kc;
  kstat_t *ksp;
  kstat_io_t kio;
  kstat_io_t *kiop;
  kstat_named_t *knamed;
  int i;

  kc = kstat_open();

  for (ksp = kc->kc_chain; ksp != NULL; ksp = ksp->ks_next) {
    if (ksp->ks_type == KSTAT_TYPE_IO)
      {
        /*kstat_read(kc, ksp, &kio);*/
        kstat_read(kc, ksp, NULL);
        kiop = KSTAT_IO_PTR(ksp);
        
        printf("module-instance-name %s-%i-%s (class: %s)\n",
               ksp->ks_module, ksp->ks_instance,
               ksp->ks_name, ksp->ks_class);
        printf("\tnread: %d, reads %u\n", kiop->nread, kiop->reads);
        printf("\trlentime: %d\n", (double) kiop->rlentime);
      }
    else if (ksp->ks_type == KSTAT_TYPE_NAMED)
      {
        kstat_read(kc, ksp, NULL);
        knamed = KSTAT_NAMED_PTR(ksp);

        /* There may be many points of data in a single NAMED kstat. */
        for (i = 0; i < ksp->ks_ndata; i++) {
          printf("%s:%s - ", ksp->ks_module, ksp->ks_name);
          
          switch (knamed[i].data_type) {
          case KSTAT_DATA_CHAR:
            printf("%s: %s\n", knamed[i].name, knamed[i].value.c);
            break;
            
          case KSTAT_DATA_INT32:
            printf("%s: %i\n", knamed[i].name, knamed[i].value.i32);
            break;
            
          case KSTAT_DATA_UINT32:
            printf("%s: %u\n", knamed[i].name, knamed[i].value.ui32);
            break;
            
          case KSTAT_DATA_INT64:
            printf("%s: %ld\n", knamed[i].name, knamed[i].value.i64);
            break;
            
          case KSTAT_DATA_UINT64:
            printf("%s: %lu\n", knamed[i].name, knamed[i].value.ui64);
            break;
          }
        }
      }
  }

  return(0);
}




/* EOF */
