/*
  $Id: wkstat.h,v 1.3 1999-11-19 13:07:24-06 annis Exp annis $
  $Source: /u/annis/code/NewMom/kstat/RCS/wkstat.h,v $

  Copyright (c) 1999, 2000 William S. Annis.  All rights reserved.
  This is free software; you can redistribute it and/or modify it
  under the same terms as Perl (the Artistic Licence).  Developed at
  the Department of Biostatistics and Medical Informatics, University
  of Wisconsin, Madison.
*/

#ifndef _WKSTAT_H
#define _WKSTAT_H

#include <kstat.h>
#include <sys/sysinfo.h>
#include <sys/dnlc.h>

/* 
   A kstat handle... holds controler instance and pointers to the
   various KSTAT_TYPE_* structs.. 
*/
typedef struct wks_kst {
  kstat_ctl_t *kctl;
  kstat_t *ksp;
  /* Handle for KSTAT_TYPE_NAMED kstats, with index. */
  kstat_named_t *knamed;
  int knamed_i;
} wks_kst_wt;


/* *Uuh*! Type checking GOOOOOOD! */
#define WKSTAT_RAW(wkc)   ((wkc)->ksp->ks_type == KSTAT_TYPE_RAW)
#define WKSTAT_NAMED(wkc) ((wkc)->ksp->ks_type == KSTAT_TYPE_NAMED)
#define WKSTAT_INTR(wkc)  ((wkc)->ksp->ks_type == KSTAT_TYPE_INTR)
#define WKSTAT_IO(wkc)    ((wkc)->ksp->ks_type == KSTAT_TYPE_IO)
#define WKSTAT_TIMER(wkc) ((wkc)->ksp->ks_type == KSTAT_TYPE_TIMER)

/* Casts for useful RAW kstats. */
/* #define KSTAT_AS_VMINFO(wkc)	*/

extern wks_kst_wt wkstat_open(void);
extern void wkstat_rewind(wks_kst_wt *wks);
extern int wkstat_next(wks_kst_wt *wks);
extern char *wkstat_name(wks_kst_wt *wks);
extern char *wkstat_class(wks_kst_wt *wks);
extern char *wkstat_module(wks_kst_wt *wks);
extern int wkstat_instance(wks_kst_wt *wks);
extern int wkstat_type(wks_kst_wt *wks);
extern long wkstat_created(wks_kst_wt *wks);
extern long wkstat_snaptime(wks_kst_wt *wks);
extern int wkstat_close(wks_kst_wt *wks);
extern char *wkstat_type_as_string(wks_kst_wt *wks);
extern kid_t wkstat_read(wks_kst_wt *wks);
extern kstat_named_t *wkstat_named_read(wks_kst_wt *wks);
extern kstat_io_t *wkstat_io_read(wks_kst_wt *wks);
extern int wkstat_update(wks_kst_wt *wks);
extern vminfo_t *wkstat_vminfo_read(wks_kst_wt *wks);
extern sysinfo_t *wkstat_sysinfo_read(wks_kst_wt *wks);
extern cpu_stat_t *wkstat_cpustat_read(wks_kst_wt *wks);
extern struct ncstats *wkstat_ncstats_read(wks_kst_wt *wks);

#endif /* _WKSTAT_H */
